#!/usr/bin/python


# For debugging proposes
#!/usr/bin/python -i
import pdb


import urllib
import urlparse
import htmllib
import httplib

import os
import string
import sys

from sgmllib import SGMLParser
from threading import *
from Queue import *



BUFFER_SIZE = 65536

# To Use It
MAX_RECURSION_LEVEL = 2

# To Test It
#MAX_RECURSION_LEVEL = 1
#MAX_RECURSION_LEVEL = 0





#HTTPTable = {'http://www.p-bot.com/':{'recursionLevel':0, 'seen':0}}

#HTTPTable = {'http://www.vidsvidsvids.com/main.html':{'recursionLevel':0, 'seen':0}}

#
# PTDownloader is the class in charge of download files
#

class PTDownloader(Thread):
	Files = []
		  
	def __init__(self, q):
		Thread.__init__(self, group = None, target = None, name = "PTDownloader", args = (), kwargs = {})
		self.queue = q

	def run(self):
		v = self.queue.get(1)
		while v != None:
#			PTDownloader.Files.append(v)
			
			fn = os.path.split(urlparse.urlparse(v['url'])[2])[1]
			out = open(fn, 'wb')
			f = v['handle'].getfile()
			buffer = f.read(BUFFER_SIZE)
			while len(buffer) > 0:
				out.write(buffer)
				buffer = f.read(BUFFER_SIZE)

			f.close()
			v['handle'].close()
			out.close()
			print "Downloaded: ", v['url']

			v = self.queue.get(1)

#		print PTDownloader.Files
		print "PTDownloader Finished"

#
# PT is the main class in charge of navigating recursively in the sites
#

class PT(SGMLParser):
	HTTPTable = {'http://www.vidsvidsvids.com/main.html':{'recursionLevel':0, 'seen':0}}
#	HTTPTable = {'http://free.vidsvidsvids.net/jumm/movie7/index015.html':{'recursionLevel':0, 'seen':0}}


	def __init__(self, verbose = 0):
		SGMLParser.__init__(self, verbose)
		self.init()


	def init(self):
		self.sites = 1
		self.queue = Queue(1000)

		self.ptdownloader = PTDownloader(self.queue)
		self.ptdownloader.start()

	def start_a(self, attrs):
		for a in attrs:
			if a[0] == 'href':
				url = urlparse.urljoin(self.currentURL, a[1])
				p = urlparse.urlparse(url)
				if p[0] == 'http' and (not PT.HTTPTable.has_key(url)):
					PT.HTTPTable[url]={}
					PT.HTTPTable[url]['seen'] = 0
					PT.HTTPTable[url]['recursionLevel'] = self.currentRecursionLevel + 1
					self.sites = self.sites + 1

	def scan_links(self, url, recursionLevel):
		self.currentURL = url
		self.currentRecursionLevel = recursionLevel
		p = urlparse.urlparse(url)
#		print p
		print MAX_RECURSION_LEVEL
		print self.currentRecursionLevel
		print "URL:", self.currentURL
		h = httplib.HTTP(p[1])
		try:
			h.putrequest('GET', p[2]+p[3]+p[4])
			# Virtual Domains: http://mail.python.org/pipermail/python-bugs-list/2000-March/000561.html
			h.putheader('Host', p[1])
			h.putheader('Accept', '*')

			h.endheaders()
	
			errcode, errmsg, header = h.getreply()

			if errcode == 200:
				if header.has_key('Content-Type'):
					if string.find(header['Content-Type'], 'text/html') >= 0:
						if self.currentRecursionLevel < MAX_RECURSION_LEVEL:
							f = h.getfile()
							self.feed(f.read())
							f.close()

							h.close()
					else:
						print "HEADER:", header['Content-Type']
#					PTDownloader.Files.append({'url':url, 'handle':f});
						self.queue.put({'url':url, 'handle':h});

# The PTDownloader is in charge of close the handler
#			h.close()

		except KeyboardInterrupt:
			print PT.HTTPTable
			sys.exit(1)

		except:
			print "ERROR (Host not found?)"

		sys.stdout.flush()

		

	def pt(self):
		while self.sites:
			for url in PT.HTTPTable.keys():
				if not PT.HTTPTable[url]['seen']:
#					print 'URL: ', url
					self.scan_links(url, PT.HTTPTable[url]['recursionLevel'])
#					print 'HTTP Table:', HTTPTable
					PT.HTTPTable[url]['seen'] = 1
					self.sites = self.sites - 1

#			print PT.HTTPTable
		print ">>> Crawling Finished"
		self.queue.put(None)
		self.ptdownloader.join()

if __name__ == '__main__':
	pt = PT()

	pt.pt()
